*/
    QuickMSG
    Copyright (C) 2014  Jeroen Vreeken <jeroen@vreeken.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef _INCLUDE_CONTACT_H_
#define _INCLUDE_CONTACT_H_

#include <stdlib.h>
#include <stdio.h>

enum contact_type {
	CONTACT_TYPE_PERSON,
	CONTACT_TYPE_GROUP,
};

enum contact_keystat {
	CONTACT_KEYSTAT_NONE,
	CONTACT_KEYSTAT_RECEIVED,
	CONTACT_KEYSTAT_VERIFIED,
};

struct contact;

struct contact *contact_alloc(void);
void contact_free(struct contact *contact);

int contact_id_set(struct contact *contact, int id);
int contact_name_set(struct contact *contact, char *name);
int contact_address_set(struct contact *contact, char *address);
int contact_members_set(struct contact *contact, char *members);
int contact_members_add(struct contact *contact, char *member);
int contact_members_remove(struct contact *contact, char *member);
int contact_type_set(struct contact *contact, enum contact_type type);
int contact_keystat_set(struct contact *contact, enum contact_keystat keystat);
int contact_time_lastact_set(struct contact *contact, time_t t);
int contact_unread_set(struct contact *contact, time_t t);
int contact_group_set(struct contact *contact, int group);

int contact_id_get(struct contact *contact);
char *contact_name_get(struct contact *contact);
char *contact_address_get(struct contact *contact);
char *contact_members_get(struct contact *contact);
enum contact_type contact_type_get(struct contact *contact);
enum contact_keystat contact_keystat_get(struct contact *contact);
time_t contact_time_lastact_get(struct contact *contact);
time_t contact_unread_get(struct contact *contact);
int contact_group_get(struct contact *contact);

char *contact_member_get(struct contact *contact, size_t nr);
size_t contact_members_get_size(struct contact *contact);


struct contact_list {
	struct contact **contacts;
	size_t size;
};

struct contact_list *contact_list_alloc(void);
void contact_list_free(struct contact_list *l);

int contact_list_add(struct contact_list *l, struct contact *c);
struct contact *contact_list_remove(struct contact_list *l, size_t c);

char *contact_print_header(void);
char *contact_print(struct contact *c);


#endif /* _INCLUDE_CONTACT_H_ */
