*/
    QuickMSG
    Copyright (C) 2014  Jeroen Vreeken <jeroen@vreeken.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef _INCLUDE_GPG_H_
#define _INCLUDE_GPG_H_

#include "attachment.h"

struct gpg;

struct gpg *gpg_alloc(void);
void gpg_free(struct gpg *gpg);

int gpg_add_key(struct gpg *gpg, struct attachment *a);
struct attachment *gpg_get_key(struct gpg *gpg, char *address);
char *gpg_get_fingerprint(struct gpg *gpg, char *address);

struct attachment *gpg_decrypt_verify(struct gpg *gpg, struct attachment *a, char *from);
struct attachment *gpg_encrypt_sign(struct gpg *gpg, struct attachment *plain, char *to);

struct attachment *pgp_mime_id_get(void);

#endif /* _INCLUDE_GPG_H_ */
