*/
    QuickMSG
    Copyright (C) 2014  Jeroen Vreeken <jeroen@vreeken.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef _INCLUDE_POST_H_
#define _INCLUDE_POST_H_

#include <time.h>

struct post;

struct post *post_alloc(void);
void post_free(struct post *post);

int post_id_set(struct post *post, int id);
int post_id_get(struct post *post);
int post_from_set(struct post *post, int from);
int post_from_get(struct post *post);
int post_time_set(struct post *post, time_t t);
time_t post_time_get(struct post *post);
int post_text_set(struct post *post, char *text);
char *post_text_get(struct post *post);
int post_uri_set(struct post *post, char *uri);
char *post_uri_get(struct post *post);

struct post_list {
	struct post **posts;
	size_t size;
};

struct post_list *post_list_alloc(void);
void post_list_free(struct post_list *l);

int post_list_add(struct post_list *l, struct post *p);
struct post *post_list_remove(struct post_list *l, size_t c);

char *post_print_header(void);
char *post_print(struct post *p);


#endif /* _INCLUDE_POST_H_ */
